SystemOrganization addCategory: #'tODE-Debugger'!

TOInspector subclass: #TOContextInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Debugger'!

!TOContextInspector methodsFor: 'accessing' stamp: 'dkh 5/29/2011 08:25'!
context

	^self object! !

!TOContextInspector methodsFor: 'accessing' stamp: 'dkh 5/29/2011 08:25'!
context: anObject

	self object: anObject! !

!TOContextInspector methodsFor: 'accessing' stamp: 'dkh 5/29/2011 08:34'!
getContextMembers
	| members tempNames |
	members := OrderedCollection new.
	members
		add:
			((TOInspectorKeylessFieldSpec new)
				keyLabel: 'thisContext';
				value: self context).
	tempNames := self context tempNames.
	self context numArgs + 1 to: tempNames size do: [ :index | 
		members
			add:
				((TOInspectorKeylessFieldSpec new)
					keyLabel: (tempNames at: index);
					value: (self context debuggerMap namedTempAt: index in: self context)) ].
	^ members! !

!TOContextInspector methodsFor: 'rendering' stamp: 'dkh 5/29/2011 08:41'!
renderMembersOn: html main: main
	html strong: 'Args:'.
	html unorderedList: [self renderBasicMembers: self getArgMembers on: html main: main].
	html strong: 'Method Context:' .
	html unorderedList: [self renderBasicMembers: self getContextMembers on: html main: main].
! !

TOInspector subclass: #TOReceiverInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Debugger'!

!TOReceiverInspector methodsFor: 'accessing' stamp: 'dkh 5/29/2011 08:42'!
receiver

	^self object! !

!TOReceiverInspector methodsFor: 'accessing' stamp: 'dkh 5/29/2011 08:42'!
receiver: anObject

	self object: anObject! !

!TOReceiverInspector methodsFor: 'rendering' stamp: 'dkh 5/29/2011 08:44'!
renderMembersOn: html main: main
	html strong: 'Self:'.
	html unorderedList: [super renderMembersOn: html main: main].
! !

TOView subclass: #TODebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Debugger'!

!TODebugger methodsFor: 'accessing' stamp: 'dkh 5/29/2011 11:04'!
tODEDebugFrameSidebarSpec

	^ {(TOTabSpec new)
		id: #debug;
		renderer: self;
		receiver: self;
		label: 'stack';
		order: 50;
		group: 'basic';
		renderSelector: #renderStackOn:spec:main:}! !

!TODebugger methodsFor: 'accessing' stamp: 'dkh 5/29/2011 11:02'!
tODEDebugFrameTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #debug;
		renderer: self;
		receiver: self;
		label: 'debug';
		order: 75;
		group: 'basic';
		sidebarSpec: self tODEDebugFrameSidebarSpec;
		renderSelector: #renderContentOn:spec:main:! !

TODebugger subclass: #TOException
	instanceVariableNames: 'frames topOfStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Debugger'!

!TOException methodsFor: 'accessing' stamp: 'dkh 5/28/2011 13:42'!
exception

	^self object! !

!TOException methodsFor: 'accessing' stamp: 'dkh 5/28/2011 17:35'!
frames

	^frames! !

!TOException methodsFor: 'rendering' stamp: 'dkh 5/30/2011 13:33'!
renderContentOn: html spec: aTOTabSpec main: main
	self frame: aTOTabSpec frame.
	html text: 'An '.
	self
		renderLink: [ :s | 
			main currentSpace push: self exception selecting: #inspect.
			main updateCenterSideHistory: s ]
		with: 'exception'
		on: html.
	html text: ':'.
	html
		unorderedList: [ 
			(html heading)
				level: 1;
				with: self exception description ].
	html paragraph: ' has occurred during the execution of the script.'.
	html
		paragraph: [ 
			html text: 'To debug, select '.
			self
				renderLink: [ :s | 
					main currentSpace push: self topOfStack selecting: #debug.
					main updateCenterSideHistory: s ]
				with: 'topOfStack'
				on: html.
			html text: ' or a frame from the list on your left.' ]! !

!TOException methodsFor: 'rendering' stamp: 'dkh 5/29/2011 17:24'!
renderStackOn: html spec: aTOSpec main: main

	self renderStackOn: html stackFrame: self main: main
! !

!TOException methodsFor: 'rendering' stamp: 'dkh 5/29/2011 11:32'!
renderStackOn: html stackFrame: aStackFrame main: main

	self frames do: [:fr |
		 | anchor |
			(anchor := html anchor)
				url: '#';
				onClick:
						(html jQuery ajax
								script: [ :s |
									self pushit: fr selecting: #debug main: main.
									main updateCenterSideHistory: s]);
				yourself.
			aStackFrame == fr
				ifTrue: [ anchor with: [:r | r strong: fr printString ]]
				ifFalse: [ anchor with: fr printString ].
			html break. ]! !

!TOException methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:49'!
topOfStack

	^topOfStack! !

TODebugger subclass: #TOStackFrame
	instanceVariableNames: 'exception previous context next receiver stackHome'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Debugger'!

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:14'!
context
	^ context! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:14'!
context: anObject

	receiver := anObject receiver.
	context := anObject! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:54'!
exception
	^ exception! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:54'!
exception: anObject
	exception := anObject! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 20:29'!
home

	| home stackFrame  |
	stackHome ifNotNil: [ ^stackHome ].
	(home := self context home) == self context
		ifTrue: [ ^stackHome := nil ].
	stackFrame := self next.
	[ stackFrame notNil ] whileTrue: [
		stackFrame context home == home ifTrue: [ ^stackHome := stackFrame ].
		stackFrame := stackFrame next ].
	^stackHome := nil! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 20:16'!
methodClass

	^(self receiverClass whichClassIncludesSelector: self methodSelector) ifNil: [self receiverClass]! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 20:17'!
methodSelector

	^self context method selector! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 19:05'!
methodSource

	^self context sourceCode! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:14'!
next
	^ next! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:14'!
next: anObject
	next := anObject! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:14'!
previous
	^ previous! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:14'!
previous: anObject
	previous := anObject! !

!TOStackFrame methodsFor: 'printing' stamp: 'dkh 5/28/2011 18:14'!
printContext: aContext on: aStream
	aContext outerContext
		ifNil: [aContext  printOn: aStream]
		ifNotNil:
			[:outerContext|
			 aStream nextPutAll: ' [] in '.
			 self printContext: outerContext on: aStream]! !

!TOStackFrame methodsFor: 'printing' stamp: 'dkh 5/28/2011 18:14'!
printOn: aStream
	self printContext: self context on: aStream! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 20:16'!
receiverClass

	^self context receiver class! !

!TOStackFrame methodsFor: 'rendering' stamp: 'dkh 5/29/2011 11:02'!
renderContentOn: html spec:  aTOTabSpec main: main
	self frame: aTOTabSpec frame.
	self renderFrameNavigationOn: html main: main.
	html break.
	html strong: self printString.
	html break.
	self renderMethodSourceOn: html main: main.
	html horizontalRule.
	((TOContextInspector new)
		object: self context;
		frame:  aTOTabSpec frame) renderMembersOn: html main: main.
	html horizontalRule.
	((TOReceiverInspector new)
		receiver: self context receiver;
		frame:  aTOTabSpec frame) renderMembersOn: html main: main.
! !

!TOStackFrame methodsFor: 'rendering' stamp: 'dkh 5/29/2011 07:50'!
renderFrameNavigationOn: html main: main
	self
		renderButton: [ :s | 
			main currentSpace push: self exception selecting: #debug.
			main updateCenterSideHistory: s ]
		label: 'exception'
		on: html.
	html break.
	self previous isNil
		ifTrue: [ html text: '<<' ]
		ifFalse: [ 
			self
				renderButton: [ :s | 
					main currentSpace push: self previous selecting: #debug.
					main updateCenterSideHistory: s ]
				label: '<<'
				on: html ].
	html text: ' frames '.
	self next isNil
		ifTrue: [ html text: '>>' ]
		ifFalse: [ 
			self
				renderButton: [ :s | 
					main currentSpace push: self next selecting: #debug.
					main updateCenterSideHistory: s ]
				label: '>>'
				on: html ].
	self home
		ifNotNil: [ :home | 
			self
				renderButton: [ :s | 
					main currentSpace push: self home selecting: #debug.
					main updateCenterSideHistory: s ]
				label: 'home context'
				on: html ].
	html break! !

!TOStackFrame methodsFor: 'rendering' stamp: 'dkh 5/30/2011 13:27'!
renderMethodSourceOn: html main: main
	
	| cat |
	self 
		renderControl: [ :id :scrpt |
			html textArea
				id: id;
				columns: (self textAreaColumns: self methodSource);
				rows: (self textAreaRows: self methodSource);
				value: self methodSource ] 
		on: html.
! !

!TOStackFrame methodsFor: 'rendering' stamp: 'dkh 5/29/2011 11:32'!
renderStackOn: html spec: aTOTabSpec main: main

	self exception renderStackOn: html stackFrame: self main: main! !
